/**
 * 
 */
package tutorialhibernate;

import javax.swing.ImageIcon;

import org.hibernate.Session;
import org.hibernate.Transaction;

import tutorialhibernate.dominio.Artista;
import tutorialhibernate.dominio.CD;
import tutorialhibernate.dominio.Gravadora;

/**
 * @author vitor
 *
 */
public class TesteCriacao {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// Obtém uma sessão (veremos depois).
		Session session = HibernateUtil.openSession();

		// Sony Music:
		Gravadora sony = new Gravadora("Sony Music");
		
		// Dave Matthews Band:
		Artista dmb = new Artista("Dave Matthews Band", true, "EUA");
		
		// Crash:
		ImageIcon fotoCrash = new ImageIcon(TesteCriacao.class.getResource("/resources/Crash.jpg"));
		
		CD crash = new CD(sony, "Crash", "1. Too Much / 2. So Much To Say / 3. Two Step / 4. Crash Into Me / 5. # 41 / 6. Say Goodbye / 7. Drive In Drive Out / 8. Let You Down / 9. Lie In Your Graves / 10. Cry Freedom / 11. Tripping Billies / 12. Proudest Monkey", 21.5, fotoCrash, false);
		dmb.addCd(crash);
		
		// Under the Table and Dreaming:
		ImageIcon fotoUtd = new ImageIcon(TesteCriacao.class.getResource("/resources/UnderTheTableAndDreaming.jpg"));
		CD utd = new CD(sony, "Under the Table and Dreaming", "1. The Best Of What´s Around / 2. What Would You Say / 3. Satelite / 4. Rhyme & Reason / 5. Typical Situation / 6. Dancing Nancies / 7. Ants Marching / 8. Lover Lay Down / 9. Jimi Thing / 10. Warehouse / 11. Pay For What You Get", 19.9, fotoUtd, false);
		dmb.addCd(utd);
		
		// Before these Crowded Streets
		ImageIcon fotoBcs = new ImageIcon(TesteCriacao.class.getResource("/resources/BeforeTheseCrowdedStreets.jpg"));
		CD bcs = new CD(sony, "Before these Crowded Streets", "1. Pantana Naga Pampa / 2. Rapunzel / 3. The Last Stop / 4. Don´t Drink The Water / 5. Stay (Wasting Time) / 6. Halloween / 7. The Stone / 8. Crush / 9. The Dreaming Tree / 10. Pig / 11. Spoon", 25.0, fotoBcs, false);
		dmb.addCd(bcs);
		
		// Grava no banco de dados.
		Transaction tx = session.beginTransaction();
		session.saveOrUpdate(sony);
		session.saveOrUpdate(dmb);
		tx.commit();
		session.close();
		
		System.out.println("Pronto! Confira no banco de dados.");
	}

}
