/**
 * 
 */
package tutorialhibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.criterion.Example;
import org.hibernate.criterion.Expression;

import tutorialhibernate.dominio.Artista;

/**
 * @author vitor
 *
 */
public class TesteCriteria {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		// Obtém uma sessão.
		Session session = HibernateUtil.openSession();
		Transaction tx = session.beginTransaction();
		
		// Recupera todos os artistas brasileiros.
		Criteria criteria = session.createCriteria(Artista.class);
		criteria.add(Expression.eq("pais", "Brasil"));
		List list = criteria.list();
		
		System.out.println("Artistas brasileiros: ");
		for (Object o : list) {
			Artista a = (Artista)o;
			System.out.println(a.getNome());
		}
		
		
		// Recupera todos os artistas norte-americanos, com busca por exemplo.
		Artista exemplo = new Artista();
		exemplo.setPais("EUA");
		criteria = session.createCriteria(Artista.class);
		criteria.add(Example.create(exemplo));
		list = criteria.list();
		
		System.out.println("Artistas dos EUA: ");
		for (Object o : list) {
			Artista a = (Artista)o;
			System.out.println(a.getNome());
		}
		
		
		tx.commit();
		session.close();
	}

}
