/**
 * 
 */
package tutorialhibernate;

import java.awt.BorderLayout;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;

import org.hibernate.Session;
import org.hibernate.Transaction;

import tutorialhibernate.dominio.Artista;
import tutorialhibernate.dominio.CD;

/**
 * @author vitor
 *
 */
public class TesteRecuperacao {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		// Obtém uma sessão (veremos depois).
		Session session = HibernateUtil.openSession();

		// Grava no banco de dados.
		Transaction tx = session.beginTransaction();
		
		// Recupera o primeiro artista gravado.
		Artista artista = (Artista)session.load(Artista.class, new Long(1));
		
		// Exibe informações em uma interface gráfica.
		JFrame janela = new JFrame("CDs de " + artista.getNome() + " (" + artista.getPais() + ")");
		janela.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		JPanel painel = new JPanel(new BorderLayout());
		janela.setContentPane(painel);
		JTabbedPane abas = new JTabbedPane(JTabbedPane.BOTTOM);
		for (CD cd : artista.getCds()) {
			JPanel painelCD = new JPanel(new BorderLayout(10, 10));
			JLabel labelGravadora = new JLabel("Gravadora: " + cd.getGravadora().getNome());
			labelGravadora.setHorizontalAlignment(JLabel.CENTER);
			JLabel labelImagem = new JLabel(cd.getFoto());
			JTextArea areaFaixas = new JTextArea(cd.getFaixas().replaceAll(" / ", "\n"));
			areaFaixas.setEditable(false);
			painelCD.add(labelGravadora, BorderLayout.PAGE_START);
			painelCD.add(labelImagem, BorderLayout.CENTER);
			painelCD.add(new JScrollPane(areaFaixas), BorderLayout.PAGE_END);
			abas.addTab(cd.getNome(), painelCD);
		}
		painel.add(abas, BorderLayout.CENTER);
		janela.pack();
		janela.setVisible(true);
		
		tx.commit();
		session.close();
	}

}
