package tutorialhibernate.dominio;

import java.util.HashSet;
import java.util.Set;

import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;

@Entity
public class Artista {
	private Long id;
	
	private String nome;
	
	private Boolean banda;
	
	private String pais;
	
	private Set<CD> cds;

	public Artista() { }
	
	/**
	 * @param nome
	 * @param banda
	 * @param pais
	 */
	public Artista(String nome, Boolean banda, String pais) {
		this.nome = nome;
		this.banda = banda;
		this.pais = pais;
	}

	/**
	 * @return the banda
	 */
	@Basic
	public Boolean getBanda() {
		return banda;
	}

	/**
	 * @param banda the banda to set
	 */
	public void setBanda(Boolean banda) {
		this.banda = banda;
	}

	/**
	 * @return the id
	 */
	@Id @GeneratedValue(strategy = GenerationType.AUTO)
	public Long getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(Long id) {
		this.id = id;
	}

	/**
	 * @return the nome
	 */
	@Column(length = 100)
	public String getNome() {
		return nome;
	}

	/**
	 * @param nome the nome to set
	 */
	public void setNome(String nome) {
		this.nome = nome;
	}

	/**
	 * @return the pais
	 */
	@Column(length = 100)
	public String getPais() {
		return pais;
	}

	/**
	 * @param pais the pais to set
	 */
	public void setPais(String pais) {
		this.pais = pais;
	}

	/**
	 * @return the cds
	 */
	@OneToMany(cascade = CascadeType.ALL, mappedBy="artista")
	public Set<CD> getCds() {
		return cds;
	}
	
	/**
	 * Adiciona um CD ao conjunto de CDs deste artista.
	 * @param cd O CD a adicionar.
	 */
	public void addCd(CD cd) { 
		if (cd == null) throw new IllegalArgumentException("CD nulo");
		if (cd.getArtista() != null) cd.getArtista().getCds().remove(cd);
		if (cds == null) cds = new HashSet<CD>();
		cd.setArtista(this);
		cds.add(cd);
	}
	
	/**
	 * @param cds the cds to set
	 */
	@SuppressWarnings("unused")
	private void setCds(Set<CD> cds) {
		this.cds = cds;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return nome;
	}
}
