package tutorialhibernate.dominio;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Lob;
import javax.persistence.ManyToOne;
import javax.swing.ImageIcon;

@Entity
public class CD {
	private Long id;
	
	private Artista artista;
	
	private Gravadora gravadora;
	
	private String nome;
	
	private String faixas;
	
	private Double preco;
	
	private ImageIcon foto;
	
	private Boolean duplo;

	CD() { }
	
	/**
	 * @param gravadora
	 * @param nome
	 * @param faixas
	 * @param preco
	 * @param foto
	 * @param duplo
	 */
	public CD(Gravadora gravadora, String nome, String faixas, Double preco, ImageIcon foto, Boolean duplo) {
		this.gravadora = gravadora;
		this.nome = nome;
		this.faixas = faixas;
		this.preco = preco;
		this.foto = foto;
		this.duplo = duplo;
	}

	/**
	 * @return the artista
	 */
	@ManyToOne
	public Artista getArtista() {
		return artista;
	}

	/**
	 * @param artista the artista to set
	 */
	public void setArtista(Artista artista) {
		this.artista = artista;
	}

	/**
	 * @return the duplo
	 */
	@Basic
	public Boolean getDuplo() {
		return duplo;
	}

	/**
	 * @param duplo the duplo to set
	 */
	public void setDuplo(Boolean duplo) {
		this.duplo = duplo;
	}

	/**
	 * @return the faixas
	 */
	@Lob
	public String getFaixas() {
		return faixas;
	}

	/**
	 * @param faixas the faixas to set
	 */
	public void setFaixas(String faixas) {
		this.faixas = faixas;
	}

	/**
	 * @return the foto
	 */
	@Lob
	public ImageIcon getFoto() {
		return foto;
	}

	/**
	 * @param foto the foto to set
	 */
	public void setFoto(ImageIcon foto) {
		this.foto = foto;
	}

	/**
	 * @return the gravadora
	 */
	@ManyToOne
	public Gravadora getGravadora() {
		return gravadora;
	}

	/**
	 * @param gravadora the gravadora to set
	 */
	public void setGravadora(Gravadora gravadora) {
		this.gravadora = gravadora;
	}

	/**
	 * @return the id
	 */
	@Id @GeneratedValue(strategy = GenerationType.AUTO)
	public Long getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(Long id) {
		this.id = id;
	}

	/**
	 * @return the nome
	 */
	@Column(length = 100)
	public String getNome() {
		return nome;
	}

	/**
	 * @param nome the nome to set
	 */
	public void setNome(String nome) {
		this.nome = nome;
	}

	/**
	 * @return the preco
	 */
	@Basic
	public Double getPreco() {
		return preco;
	}

	/**
	 * @param preco the preco to set
	 */
	public void setPreco(Double preco) {
		this.preco = preco;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return nome + " (" + artista + ")";
	}
}
